using UnityEngine;

public class Storyline : MonoBehaviour {
    public Node currentNode;
    [SerializeField] Katas.Experimental.WorldSpaceUIDocument worldSpaceUIDocument;


    public void Start() {
        Transition[] GHI = new Transition[2];
        Node testNode = new Node("Actor 3","Testing Text 3",GHI);

        Transition testTransition = new Transition("Continue", testNode);
        Transition[] ABC = new Transition[1];
        ABC[0] = testTransition;
        Node TestNode2 = new Node("Actor 2","Testing Text 2", ABC);

        Transition testTransition1 = new Transition("Yes", TestNode2);
        Transition[] DEF = new Transition[1];
        DEF[0] = testTransition1;
        Node testNode3 = new Node("Actor 1","Testing Text 1", DEF);

        Transition testTransition2 = new Transition("No", testNode3);
        GHI[0] = testTransition1;
       
        Transition[] JKL = new Transition[5];
        JKL[0] = testTransition1;
        JKL[1] = testTransition2;
        JKL[3] = testTransition;
        JKL[4] = testTransition1;

        Node testNode4 = new Node("Actor 4", "Testing Text 4", JKL);

        Transition testTransition3 = new Transition("Unsure", testNode4);
        GHI[1] = testTransition3;
        JKL[2] = testTransition3;

        currentNode = testNode4;
        worldSpaceUIDocument.onUIDocumentReady.AddListener(UpdateUi);
    }

    public void ApplyTransition(int count) {
        currentNode = currentNode.transitions[count].target;
        UpdateUi();
    }

    public void UpdateUi() {
        var dialogueBox = GetComponent<DialogueBox>();
        dialogueBox.SetActor(currentNode.actorName);
        dialogueBox.SetText(currentNode.dialogueText);
        dialogueBox.SetTransitions(currentNode.transitions);
    }


    public class Node {
        public readonly string actorName;
        public readonly string dialogueText;
        public readonly Transition[] transitions;

        public Node(string actor, string dialogue) {
            actorName = actor;
            dialogueText = dialogue;
        }

        public Node(string actor, string dialogue, Transition[] transitions) : this(actor, dialogue) {
            this.transitions = transitions;
        }
    }

    
    public class Transition {
        public readonly string transitionText;
        public readonly Node target;

        public Transition(string text, Node target) {
            transitionText = text;
            this.target = target;
        }
    }
}